/*
 * Copyright (c) 2015 - 2016 , Freescale Semiconductor, Inc.
 * Copyright 2016-2018 NXP
 * All rights reserved.
 *
 * THIS SOFTWARE IS PROVIDED BY NXP "AS IS" AND ANY EXPRESSED OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL NXP OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
 * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */
/*
 * FTM2.c
 *
 *  Created on: 01.10.2019
 *      Author: nxp52415
 */
#include "FTM2.h"

void FTM2_init(void) {
//  PCC->PCCn[PCC_FTM2_INDEX] &= ~PCC_PCCn_CGC_MASK;  /* Ensure clk disabled for config */
//  PCC->PCCn[PCC_FTM2_INDEX] |= PCC_PCCn_PCS(3)  /* CClock Src= 3 FRIC */
//                                |  PCC_PCCn_CGC_MASK;   /* Enable clock for FTM regs */
  FTM2->MODE = 7;  /* Write protect to registers disabled (default) */
  FTM2->SC = 0x10000;
  FTM2->CONF = 0xC0;
  FTM2->SYNCONF = 0x1F80;
  FTM2->CNT = 0;
                             /* TOIE (Timer Overflow Interrupt Ena) = 0 (default) */
                             /* CPWMS (Center aligned PWM Select) = 0 (default, up count) */
                             /* CLKS (Clock source) = 0 (default, no clock; FTM disabled) */
                             /* PS (Prescaler factor) = 1. Prescaler = 1 */
  FTM2->COMBINE = 0x00000000;/* FTM mode settings used: DECAPENx, MCOMBINEx, COMBINEx=0  */
  FTM2->SYNC = 2;
  FTM2->POL = 0x00000000;    /* Polarity for all channels is active high (default) */
  FTM2->CNTIN = 0;
  FTM2->MOD = 62500 ;
}

void FTM2_CH0_OC_init(void) {
  FTM2->CONTROLS[0].CnSC = 0x00000055;
  FTM2->CONTROLS[0].CnV = 0;
  FTM2->OUTINIT = 0;

}

void start_FTM2_counter (void) {
  FTM2->SC |= FTM_SC_CLKS(2);
                      /* Start FTM input clock*/
}
void stop_FTM2_counter(void) {
  FTM2->SC &= ~FTM_SC_CLKS_MASK;
}
