/*
 * Copyright (c) 2015 - 2016 , Freescale Semiconductor, Inc.
 * Copyright 2016-2018 NXP
 * All rights reserved.
 *
 * THIS SOFTWARE IS PROVIDED BY NXP "AS IS" AND ANY EXPRESSED OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL NXP OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
 * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * sent_encode.c
 *
 *  Created on: 08.10.2019
 *      Author: nxp52415
 */

#include "sent_encode.h"

const uint8_t CRC_4bit [256] =
{ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15,
  13, 12, 15, 14, 9, 8, 11, 10, 5, 4, 7, 6, 1, 0, 3, 2,
  7, 6, 5, 4, 3, 2, 1, 0, 15, 14, 13, 12, 11, 10, 9, 8,
  10, 11, 8, 9, 14, 15, 12, 13, 2, 3, 0, 1, 6, 7, 4, 5,
  14, 15, 12, 13, 10, 11, 8, 9, 6, 7, 4, 5, 2, 3, 0, 1,
  3, 2, 1, 0, 7, 6, 5, 4, 11, 10, 9, 8, 15, 14, 13, 12,
  9, 8, 11, 10, 13, 12, 15, 14, 1, 0, 3, 2, 5, 4, 7, 6,
  4, 5, 6, 7, 0, 1, 2, 3, 12, 13, 14, 15, 8, 9, 10, 11,
  1, 0, 3, 2, 5, 4, 7, 6, 9, 8, 11, 10, 13, 12, 15, 14,
  12, 13, 14, 15, 8, 9, 10, 11, 4, 5, 6, 7, 0, 1, 2, 3,
  6, 7, 4, 5, 2, 3, 0, 1, 14, 15, 12, 13, 10, 11, 8, 9,
  11, 10, 9, 8, 15, 14, 13, 12, 3, 2, 1, 0, 7, 6, 5, 4,
  15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0,
  2, 3, 0, 1, 6, 7, 4, 5, 10, 11, 8, 9, 14, 15, 12, 13,
  8, 9, 10, 11, 12, 13, 14, 15, 0, 1, 2, 3, 4, 5, 6, 7,
  5, 4, 7, 6, 1, 0, 3, 2, 13, 12, 15, 14, 9, 8, 11, 10};

 volatile uint8_t crc = 5; // crc seed

uint32_t sentEncodeNextNibble (uint8_t value)
{
  static uint8_t index = 3;
  uint32_t ret = NO_LAST_NIBBLE_MESSAGE;
  static volatile uint8_t temp = 0;

  if (index >= 5)
  {
    temp = crc << 4;
    crc = CRC_4bit[(temp) + value];
  }

  dmaBuffer[index] = dmaBuffer[index -1] + (TICKS_PULSE_DOWN * COUNTS_PER_TICK);
  index++;
  dmaBuffer[index] = dmaBuffer[index -1] + ((value + TICKS_DATA_PREFACE) * COUNTS_PER_TICK);
  index++;


  if (index == 17)
  {
    //crc
    temp = crc << 4;
    crc = CRC_4bit[temp];
    dmaBuffer[index] = dmaBuffer[index -1] + (TICKS_PULSE_DOWN * COUNTS_PER_TICK);
    index++;
    dmaBuffer[index] = dmaBuffer[index -1] + ((crc + TICKS_DATA_PREFACE) * COUNTS_PER_TICK);
    index++;

    //pause
    dmaBuffer[index] = dmaBuffer[index -1] + (TICKS_PULSE_DOWN * COUNTS_PER_TICK);
    index++;
    dmaBuffer[index] = dmaBuffer[index -1] + ((TICKS_DATA_PREFACE) * COUNTS_PER_TICK);
    index++;
    dmaBuffer[index] = dmaBuffer[index -1] + (TICKS_PULSE_DOWN * COUNTS_PER_TICK);

    index = 3;
    crc = 5;
    ret = LAST_NIBBLE_MESSAGE;
  }

  return ret;
}


